; PID control for two wheel robot on SX (Ubicom) microcontroller.
; Copyright (C) 1999-2001 Blaise Gassend <blaise at gassend dot com>
; 
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	ifndef	??version
?debug	macro
	endm
publicdll macro	name
	public	name
	endm
	endif
	?debug	V 300h
	?debug	S "SXPROG.C"
	?debug	C E9D7802D2808535850524F472E43
	?debug	C E94019CA181B433A5C424F524C414E44435C494E434C5544455C53+
	?debug	C 5444494F2E48
	?debug	C E94019CA181B433A5C424F524C414E44435C494E434C5544455C5F+
	?debug	C 444546532E48
	?debug	C E94019CA181C433A5C424F524C414E44435C494E434C5544455C5F+
	?debug	C 4E46494C452E48
	?debug	C E94019CA181B433A5C424F524C414E44435C494E434C5544455C5F+
	?debug	C 4E554C4C2E48
	?debug	C E94019CA181B433A5C424F524C414E44435C494E434C5544455C43+
	?debug	C 4F4E494F2E48
	?debug	C E94019CA1819433A5C424F524C414E44435C494E434C5544455C44+
	?debug	C 4F532E48
_TEXT	segment byte public 'CODE'
_TEXT	ends
DGROUP	group	_DATA,_BSS
	assume	cs:_TEXT,ds:DGROUP
_DATA	segment word public 'DATA'
d@	label	byte
d@w	label	word
_DATA	ends
_BSS	segment word public 'BSS'
b@	label	byte
b@w	label	word
_BSS	ends
_DATA	segment word public 'DATA'
_OutWord	label	word
	db	4
	db	0
_DATA	ends
_TEXT	segment byte public 'CODE'
	?debug	C E80108535850524F472E43D7802D28
	?debug	L 9
	assume	cs:_TEXT
_OutPar	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 11
 	mov	 ax,DGROUP:_OutWord
	?debug	L 12
 	mov	 dx,3BCh
	?debug	L 13
 	out	 dx,al
	?debug	L 14
	pop	bp
	ret	
	?debug	E
	?debug	E
_OutPar	endp
	?debug	L 16
	assume	cs:_TEXT
_OSC2Up	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 18
	or	word ptr DGROUP:_OutWord,4
	?debug	L 19
	call	near ptr _OutPar
	?debug	L 20
	pop	bp
	ret	
	?debug	E
	?debug	E
_OSC2Up	endp
	?debug	L 22
	assume	cs:_TEXT
_OSC2Down	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 24
	and	word ptr DGROUP:_OutWord,-5
	?debug	L 25
	call	near ptr _OutPar
	?debug	L 26
	pop	bp
	ret	
	?debug	E
	?debug	E
_OSC2Down	endp
	?debug	L 28
	assume	cs:_TEXT
_OSC1Up	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 30
	or	word ptr DGROUP:_OutWord,2
	?debug	L 31
	and	word ptr DGROUP:_OutWord,-2
	?debug	L 32
	call	near ptr _OutPar
	?debug	L 33
	pop	bp
	ret	
	?debug	E
	?debug	E
_OSC1Up	endp
	?debug	L 35
	assume	cs:_TEXT
_OSC1Down	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 37
	and	word ptr DGROUP:_OutWord,-4
	?debug	L 38
	call	near ptr _OutPar
	?debug	L 39
	pop	bp
	ret	
	?debug	E
	?debug	E
_OSC1Down	endp
	?debug	L 41
	assume	cs:_TEXT
_OSC1Prog	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	?debug	B
	?debug	L 43
	or	word ptr DGROUP:_OutWord,1
	?debug	L 44
	and	word ptr DGROUP:_OutWord,-3
	?debug	L 45
	call	near ptr _OutPar
	?debug	L 46
	pop	bp
	ret	
	?debug	E
	?debug	E
_OSC1Prog	endp
	?debug	L 48
	assume	cs:_TEXT
_In	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	sub	sp,2
	?debug	B
	?debug	L 52
 	mov	 dx,3BDh
	?debug	L 53
 	in	 al,dx
	?debug	L 54
 	xor	 ah,ah
	?debug	L 55
 	mov	 [bp-2],ax
	?debug	L 57
	test	word ptr [bp-2],128
	jne	short @7@198
	mov	ax,1
	jmp	short @7@226
@7@198:
	xor	ax,ax
@7@226:
	jmp	short @7@254
@7@254:
	?debug	L 58
	mov	sp,bp
	pop	bp
	ret	
	?debug	C E601690402FEFF00
	?debug	E
	?debug	E
_In	endp
	?debug	L 60
	assume	cs:_TEXT
_InitProg	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	push	si
	?debug	B
	?debug	L 64
	mov	ax,offset DGROUP:s@
	push	ax
	call	near ptr _printf
	pop	cx
	?debug	L 66
	call	near ptr _OSC1Down
	?debug	L 67
	call	near ptr _OSC2Down
	?debug	L 68
	xor	si,si
	jmp	short @8@114
@8@58:
	?debug	L 70
	mov	ax,1
	push	ax
	call	near ptr _delay
	pop	cx
	?debug	L 71
	call	near ptr _OSC1Up
	?debug	L 72
	mov	ax,1
	push	ax
	call	near ptr _delay
	pop	cx
	?debug	L 73
	call	near ptr _OSC1Down
	?debug	L 68
	inc	si
@8@114:
	cmp	si,15
	jl	short @8@58
	?debug	L 75
	call	near ptr _OSC2Up
	?debug	L 76
	call	near ptr _OSC1Prog
	?debug	L 78
	mov	ax,offset DGROUP:s@+12
	push	ax
	call	near ptr _printf
	pop	cx
	?debug	L 79
	pop	si
	pop	bp
	ret	
	?debug	C E6016904040600
	?debug	E
	?debug	E
_InitProg	endp
	?debug	L 96
	assume	cs:_TEXT
_sxcmd	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	sub	sp,12
	push	si
	?debug	C E60472657073040A06000007636F6D6D616E6404+
	?debug	C 0A040000
	?debug	B
	?debug	L 98
	mov	word ptr [bp-2],0
	?debug	L 99
	mov	word ptr [bp-4],-1
	?debug	L 100
	mov	word ptr [bp-6],5
	?debug	L 101
	mov	word ptr [bp-8],0
	?debug	L 102
	mov	word ptr [bp-10],0
	?debug	L 103
	xor	si,si
	?debug	L 104
	mov	word ptr [bp-12],0
	?debug	L 106
	cmp	word ptr [bp+6],0
	jne	short @9@114
	xor	ax,ax
@9@86:
	jmp	@9@2522
@9@114:
	?debug	L 108
 	cli	
	?debug	L 109
 	push	 es
	?debug	L 110
 	mov	 ax,0B800h
	?debug	L 111
 	mov	 es,ax
@9@226:
	?debug	L 133
		mov			cx,(160)
	?debug	L 134
 	mov	 	dx,3BDh
@9@282:
	?debug	L 137
 	in			al,dx
	?debug	L 138
 	test		al,80h
	?debug	L 139
	je	short @9@422
	?debug	L 140
	loop	short @9@282
@9@394:
	?debug	L 141
	mov	si,3
	?debug	L 142
	jmp	@9@2438
@9@422:
	?debug	L 145
 	xor			bx,bx
	?debug	L 146
 	mov			cx,7
@9@478:
	?debug	L 149
 	mov	 	dx,3BCh
	?debug	L 150
 	mov			al,5
	?debug	L 151
 	out			dx,al
	?debug	L 152
 	inc			dx
@9@590:
	?debug	L 155
 	in			al,dx
	?debug	L 156
 	test		al,80h
	?debug	L 157
	jne	short @9@1514
	?debug	L 158
	loop	short @9@590
	?debug	L 159
		or			bx,bx
	?debug	L 160
	je	short @9@786
	jmp	short @9@394
@9@786:
	?debug	L 167
 	inc	 [bp-12]
	?debug	L 168
 	mov	 bx,1600
	?debug	L 169
 	add	 bx,word ptr [bp-10]
	?debug	L 170
 	add	 bx,word ptr [bp-10]
	?debug	L 171
 	inc	 es:[bx]
	?debug	L 172
 	cmp			word ptr [bp-10],16
	?debug	L 173
	jne	short @9@1318
	?debug	L 174
		mov			ax,[bp-8]
	?debug	L 175
		sub			[bp+6],ax
	?debug	L 176
	je	short @9@2438
	?debug	L 177
		mov			word ptr [bp-8],1
	?debug	L 178
		mov			ax,[bp+4]
	?debug	L 179
		mov	   [bp-4],ax
	?debug	L 180
 	mov	   word ptr [bp-6],13 
	?debug	L 181
		stc	
	?debug	L 182
 	rol			word ptr [bp-4],1
	?debug	L 183
	jc	short @9@1290
	?debug	L 184
		and			word ptr [bp-6],0FBH
@9@1290:
	?debug	L 186
	jmp	short @9@1402
@9@1318:
	?debug	L 190
 	cmp			word ptr [bp-8],0
	?debug	L 191
	je	short @9@1402
	?debug	L 192
	mov	si,2
	?debug	L 193
	jmp	@9@2438
@9@1402:
	?debug	L 197
 	mov			word ptr [bp-10],0
	?debug	L 198
 	inc			bx
	?debug	L 199
 	mov			cx,(160)
	?debug	L 200
	jmp	@9@478
@9@1514:
	?debug	L 204
 	mov			bx,2*7+640
	?debug	L 205
		sub			bx,cx
	?debug	L 206
 	sub			bx,cx
	?debug	L 207
 	cmp			word ptr [bp-12],0
	?debug	L 211
		inc	 	byte ptr es:[bx]
	?debug	L 212
 	in			al,dx
	?debug	L 213
 	in			al,dx
	?debug	L 215
 	mov	 	ax,[bp-6]
	?debug	L 216
 	dec			dx
	?debug	L 217
 	out			dx,al
	?debug	L 218
 	inc	 	dx
	?debug	L 219
 	in			al,dx
	?debug	L 220
 	in			al,dx
	?debug	L 221
 	in			al,dx
	?debug	L 223
 	mov			ah,al
	?debug	L 224
 	in			al,dx
	?debug	L 225
 	in			al,dx
	?debug	L 226
 	in			al,dx
	?debug	L 227
 	mov			al,[bp-6] 
	?debug	L 228
 	or			al,1 
	?debug	L 229
 	dec			dx
	?debug	L 230
 	out			dx,al
	?debug	L 233
 	shl			word ptr [bp-2],1
	?debug	L 234
 	test		ah,80h
	?debug	L 235
	jne	short @9@2242
	?debug	L 236
 	inc			word ptr [bp-2]
@9@2242:
	?debug	L 239
 	mov	   word ptr [bp-6],5
	?debug	L 240
		stc	
	?debug	L 241
 	rol			word ptr [bp-4],1
	?debug	L 242
	jc	short @9@2382
	?debug	L 243
		and			word ptr [bp-6],0FBH
@9@2382:
	?debug	L 246
 	inc			word ptr [bp-10]
	?debug	L 247
	jmp	@9@226
@9@2438:
	?debug	L 251
 	pop	 es
	?debug	L 252
 	sti	
	?debug	L 253
	call	near ptr _OutPar
	?debug	L 254
	mov	ax,si
	mov	cl,12
	shl	ax,cl
	push	ax
	mov	ax,word ptr [bp-2]
	and	ax,4095
	pop	dx
	or	ax,dx
	jmp	@9@86
@9@2522:
	?debug	L 255
	pop	si
	mov	sp,bp
	pop	bp
	ret	
	?debug	C E60673796E6365640402F4FF00056572726F7204+
	?debug	C 04060005636F756E740402F6FF000576616C6964+
	?debug	C 0402F8FF00076F7574627974650402FAFF000474+
	?debug	C 6F73780402FCFF000666726F6D73780402FEFF00+
	?debug	C 07636F6D6D616E64040A0400000472657073040A+
	?debug	C 060000
	?debug	E
	?debug	E
_sxcmd	endp
	?debug	L 259
	assume	cs:_TEXT
_OutSer	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	sub	sp,2
	?debug	C E60376616C040A040000
	?debug	B
	?debug	L 261
	mov	word ptr [bp-2],0
	jmp	short @10@58
@10@58:
	?debug	L 262
	cmp	word ptr [bp-2],0
	je	short @10@114
	call	near ptr _kbhit
	or	ax,ax
	jne	short @10@142
@10@114:
	mov	dx,765
	in	al,dx
	mov	ah,0
	test	ax,32
	je	short @10@58
@10@142:
	?debug	L 263
	mov	dx,760
	mov	al,byte ptr [bp+4]
	out	dx,al
	?debug	L 264
	mov	sp,bp
	pop	bp
	ret	
	?debug	C E601690402FEFF000376616C040A040000
	?debug	E
	?debug	E
_OutSer	endp
	?debug	L 266
	assume	cs:_TEXT
_InSer	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	sub	sp,2
	?debug	B
	?debug	L 268
	mov	word ptr [bp-2],1
	jmp	short @11@58
@11@58:
	?debug	L 269
	cmp	word ptr [bp-2],0
	je	short @11@114
	call	near ptr _kbhit
	or	ax,ax
	jne	short @11@142
@11@114:
	mov	dx,765
	in	al,dx
	mov	ah,0
	test	ax,1
	je	short @11@58
@11@142:
	?debug	L 270
	mov	dx,760
	in	al,dx
	mov	ah,0
	jmp	short @11@170
@11@170:
	?debug	L 271
	mov	sp,bp
	pop	bp
	ret	
	?debug	C E601690402FEFF00
	?debug	E
	?debug	E
_InSer	endp
	?debug	L 273
	assume	cs:_TEXT
_main	proc	near
	?debug	B
	push	bp
	mov	bp,sp
	sub	sp,10
	push	si
	push	di
	?debug	C E60461726763040A040000
	?debug	B
	?debug	L 275
	xor	si,si
	xor	di,di
	mov	word ptr [bp-2],0
	mov	word ptr [bp-4],0
	mov	word ptr [bp-6],0
	?debug	L 284
	call	near ptr _OutPar
	?debug	L 286
	cmp	word ptr [bp+4],1
	jle	short @12@86
	mov	ax,offset DGROUP:s@+19
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@86:
	?debug	L 288
	mov	dx,761
	mov	al,0
	out	dx,al
	?debug	L 289
	mov	dx,763
	mov	al,128
	out	dx,al
	?debug	L 290
	mov	dx,760
	mov	al,1
	out	dx,al
	?debug	L 291
	mov	dx,761
	mov	al,0
	out	dx,al
	?debug	L 292
	mov	dx,763
	mov	al,3
	out	dx,al
	?debug	L 293
	mov	dx,764
	mov	al,0
	out	dx,al
	?debug	L 294
	mov	dx,760
	in	al,dx
	?debug	L 296
	cmp	word ptr [bp+4],1
	jle	short @12@142
	mov	ax,offset DGROUP:s@+35
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@142:
	?debug	L 298
	mov	ax,33
	push	ax
	call	near ptr _OutSer
	pop	cx
	jmp	@12@1402
@12@170:
	?debug	L 303
	mov	ax,offset DGROUP:s@+41
	push	ax
	call	near ptr _printf
	pop	cx
	?debug	L 304
	mov	ax,offset DGROUP:__streams+16
	push	ax
	call	near ptr _fflush
	pop	cx
	?debug	L 305
	mov	ax,word ptr [bp-6]
	mov	cl,12
	shl	ax,cl
	mov	dx,si
	and	dx,4095
	or	dx,ax
	mov	si,dx
	?debug	L 306
	cmp	word ptr [bp+4],1
	jle	short @12@226
	push	si
	mov	ax,offset DGROUP:s@+48
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,6
@12@226:
	?debug	L 307
	mov	ax,42
	push	ax
	call	near ptr _OutSer
	pop	cx
	?debug	L 308
	cmp	word ptr [bp+4],1
	jle	short @12@282
	?debug	L 309
	call	near ptr _InSer
	mov	word ptr [bp-2],ax
@12@282:
	?debug	L 310
	cmp	word ptr [bp+4],1
	jle	short @12@338
	mov	ax,offset DGROUP:s@+57
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@338:
	?debug	L 311
	mov	ax,si
	mov	cl,8
	shr	ax,cl
	push	ax
	call	near ptr _OutSer
	pop	cx
	?debug	L 312
	cmp	word ptr [bp+4],1
	jle	short @12@394
	mov	ax,offset DGROUP:s@+59
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@394:
	?debug	L 313
	call	near ptr _InSer
	mov	word ptr [bp-4],ax
	?debug	L 314
	cmp	word ptr [bp+4],1
	jle	short @12@450
	mov	ax,offset DGROUP:s@+61
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@450:
	?debug	L 315
	mov	ax,si
	and	ax,255
	push	ax
	call	near ptr _OutSer
	pop	cx
	?debug	L 316
	cmp	word ptr [bp+4],1
	jle	short @12@506
	mov	ax,offset DGROUP:s@+63
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@506:
	?debug	L 317
	call	near ptr _InSer
	mov	cl,8
	shl	ax,cl
	mov	di,ax
	?debug	L 318
	cmp	word ptr [bp+4],1
	jle	short @12@562
	mov	ax,offset DGROUP:s@+65
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@562:
	?debug	L 319
	mov	ax,si
	mov	cl,8
	shr	ax,cl
	mov	dx,si
	and	dx,255
	xor	dx,ax
	xor	dx,255
	push	dx
	call	near ptr _OutSer
	pop	cx
	?debug	L 320
	cmp	word ptr [bp+4],1
	jle	short @12@618
	mov	ax,offset DGROUP:s@+67
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@618:
	?debug	L 321
	call	near ptr _InSer
	or	di,ax
	?debug	L 322
	cmp	word ptr [bp+4],1
	jle	short @12@674
	mov	ax,offset DGROUP:s@+69
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@674:
	?debug	L 324
	cmp	word ptr [bp+4],1
	jle	short @12@730
	push	word ptr [bp-4]
	push	di
	push	word ptr [bp-2]
	mov	ax,offset DGROUP:s@+71
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,10
@12@730:
	?debug	L 326
	cmp	word ptr [bp-6],0
	je	short @12@786
	mov	ax,offset DGROUP:s@+92
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
@12@786:
	?debug	L 328
	call	near ptr _kbhit
	or	ax,ax
	je	short @12@842
	jmp	@12@1430
@12@842:
	?debug	L 329
	xor	ax,ax
	mov	si,ax
	mov	word ptr [bp-6],ax
	?debug	L 331
	mov	bx,word ptr [bp-2]
	cmp	bx,9
	jbe	@@34
	jmp	@12@1374
@@34:
	shl	bx,1
	jmp	word ptr cs:@12@C1490[bx]
@12@954:
	?debug	L 334
	mov	ax,offset DGROUP:s@+94
@12@982:
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	pop	cx
	pop	cx
	?debug	L 335
	jmp	@12@1402
@12@1010:
	?debug	L 337
	mov	ax,word ptr DGROUP:_OutWord
	and	ax,4
	mov	dx,di
	and	dx,1
	shl	dx,1
	or	ax,dx
	mov	dx,di
	and	dx,2
	shr	dx,1
	or	ax,dx
	mov	word ptr DGROUP:_OutWord,ax
	?debug	L 338
	call	near ptr _OutPar
	?debug	L 339
	test	word ptr DGROUP:_OutWord,1
	je	short @12@1066
	mov	ax,15
	jmp	short @12@1150
@12@1066:
	test	word ptr DGROUP:_OutWord,2
	je	short @12@1122
	mov	ax,5
	jmp	short @12@1150
@12@1122:
	xor	ax,ax
@12@1150:
	push	ax
	mov	ax,offset DGROUP:s@+99
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,6
	?debug	L 340
	jmp	@12@1402
@12@1178:
	?debug	L 342
	test	di,1
	je	short @12@1234
	call	near ptr _OSC2Up
	jmp	short @12@1262
@12@1234:
	call	near ptr _OSC2Down
@12@1262:
	?debug	L 343
	mov	ax,di
	and	ax,1
	mov	word ptr [bp-10],ax
	mov	word ptr [bp-8],0
	fild	dword ptr [bp-10]
	fmul	dword ptr DGROUP:s@+119
	sub	sp,8
	fstp	qword ptr [bp-22]
	mov	ax,offset DGROUP:s@+109
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	fwait	
	call	near ptr _fprintf
	add	sp,12
	?debug	L 344
	jmp	@12@1402
@12@1290:
	?debug	L 346
	mov	si,di
	?debug	L 347
	push	di
	mov	ax,offset DGROUP:s@+123
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,6
	?debug	L 348
	jmp	short @12@1402
@12@1318:
	?debug	L 350
	push	word ptr [bp-4]
	push	di
	call	near ptr _sxcmd
	pop	cx
	pop	cx
	mov	si,ax
	?debug	L 351
	mov	ax,si
	mov	cl,12
	shr	ax,cl
	mov	word ptr [bp-6],ax
	?debug	L 352
	and	si,4095
	?debug	L 353
	push	word ptr [bp-4]
	mov	ax,di
	and	ax,4095
	push	ax
	push	word ptr [bp-2]
	mov	ax,offset DGROUP:s@+136
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,10
	?debug	L 354
	jmp	short @12@1402
@12@1346:
	?debug	L 356
	mov	ax,33
	push	ax
	call	near ptr _OutSer
	pop	cx
	?debug	L 357
	xor	ax,ax
	mov	word ptr [bp-2],ax
	mov	word ptr [bp-4],ax
	mov	di,ax
	mov	si,ax
	mov	word ptr [bp-6],ax
	?debug	L 358
	mov	ax,offset DGROUP:s@+159
	jmp	@12@982
@12@1374:
	?debug	L 361
	push	word ptr [bp-2]
	mov	ax,offset DGROUP:s@+166
	push	ax
	mov	ax,offset DGROUP:__streams+32
	push	ax
	call	near ptr _fprintf
	add	sp,6
	?debug	L 362
	mov	word ptr [bp-6],1
	?debug	L 363
	jmp	short @12@1402
@12@1402:
	?debug	L 300
	call	near ptr _kbhit
	or	ax,ax
	jne	@@35
	jmp	@12@170
@@35:
@12@1430:
	?debug	L 385
	call	near ptr _OSC1Down
	?debug	L 386
	call	near ptr _OSC2Up
	?debug	L 388
 	sti	
	jmp	short @12@1542
@12@1514:
	?debug	L 390
	call	near ptr _getch
@12@1542:
	call	near ptr _kbhit
	or	ax,ax
	jne	short @12@1514
	?debug	L 391
	pop	di
	pop	si
	mov	sp,bp
	pop	bp
	ret	
	?debug	C E6056572726F720A02FAFF0006726570636E740A+
	?debug	C 02FCFF00057063636D640A02FEFF000670636461+
	?debug	C 74610A040700067378646174610A040600046172+
	?debug	C 6763040A040000
	?debug	E
	?debug	E
_main	endp
@12@C1490	label	word
	dw	@12@954
	dw	@12@1010
	dw	@12@1178
	dw	@12@1290
	dw	@12@1318
	dw	@12@1374
	dw	@12@1374
	dw	@12@1374
	dw	@12@1374
	dw	@12@1346
	?debug	C E9
	?debug	C FA00000000
_TEXT	ends
_DATA	segment word public 'DATA'
s@	label	byte
	db	'InitProg...'
	db	0
	db	'.done'
	db	10
	db	0
	db	'Initialising...'
	db	0
	db	'.done'
	db	0
	db	'     '
	db	13
	db	0
	db	'SX:%04x-'
	db	0
	db	'i'
	db	0
	db	'o'
	db	0
	db	'i'
	db	0
	db	'o'
	db	0
	db	'i'
	db	0
	db	'o'
	db	0
	db	'i'
	db	0
	db	'-PC:%02x(%04x)x%-3i '
	db	0
	db	10
	db	0
	db	' NOP'
	db	0
	db	' OSC1=%iV'
	db	0
	db	' OSC2=%iV'
	db	0
	db	0
	db	0
	db	'`@ ECHO (%04x)'
	db	0
	db	' SXCMD %02x(%03x)x%-3i'
	db	0
	db	' RESET'
	db	0
	db	' INVALID (%02x)'
	db	0
_DATA	ends
_TEXT	segment byte public 'CODE'
_TEXT	ends
	extrn	__setargv__:far
	public	_main
	public	_InSer
	public	_OutSer
	public	_sxcmd
	public	_InitProg
	public	_In
	public	_OSC1Prog
	public	_OSC1Down
	public	_OSC1Up
	public	_OSC2Down
	public	_OSC2Up
	public	_OutPar
	public	_OutWord
	extrn	_delay:near
	extrn	_kbhit:near
	extrn	_getch:near
	extrn	_printf:near
	extrn	_fprintf:near
	extrn	_fflush:near
	extrn	__streams:word
_s@	equ	s@
	?debug	C EA0109
	?debug	C E31800000023040500
	?debug	C EB0B5F5F736574617267765F5F1800
	?debug	C E31900000023010000
	?debug	C EC055F6D61696E191800
	?debug	C E31A00000023040000
	?debug	C EC065F496E5365721A1800
	?debug	C E31B00000023010000
	?debug	C EC075F4F75745365721B1800
	?debug	C E31C00000023040000
	?debug	C EC065F7378636D641C1800
	?debug	C E31D00000023010000
	?debug	C EC095F496E697450726F671D1800
	?debug	C E31E00000023040000
	?debug	C EC035F496E1E1800
	?debug	C E31F00000023010000
	?debug	C EC095F4F53433150726F671F1800
	?debug	C E32000000023010000
	?debug	C EC095F4F534331446F776E201800
	?debug	C E32100000023010000
	?debug	C EC075F4F5343315570211800
	?debug	C E32200000023010000
	?debug	C EC095F4F534332446F776E221800
	?debug	C E32300000023010000
	?debug	C EC075F4F5343325570231800
	?debug	C E32400000023010000
	?debug	C EC075F4F7574506172241800
	?debug	C EC085F4F7574576F7264040000
	?debug	C E32500000023010000
	?debug	C EB065F64656C61792500
	?debug	C E32600000023040000
	?debug	C EB065F6B626869742600
	?debug	C E32700000023040000
	?debug	C EB065F67657463682700
	?debug	C E32800000023040001
	?debug	C EB075F7072696E74662800
	?debug	C E32900000023040001
	?debug	C EB085F667072696E74662900
	?debug	C E32A00000023040000
	?debug	C EB075F66666C7573682A00
	?debug	C E32C0010001E01
	?debug	C E32D000200150804
	?debug	C E32B0000001A2C
	?debug	C EB095F5F73747265616D732B00
	?debug	C E60446494C452C06000666706F735F7406060006+
	?debug	C 73697A655F740A0600
	?debug	C E200056C6576656C040005666C6167730A000266+
	?debug	C 64020004686F6C640800056273697A6504000662+
	?debug	C 75666665722D0004637572702D0006697374656D+
	?debug	C 700A0005746F6B656E04C010000000
	end
